<?php

namespace Bydedi\Catalog;

use Bydedi\Container\ServiceProvider;
use Symfony\Component\Config\FileLocator;
use Symfony\Component\DependencyInjection\Loader\YamlFileLoader;

/**
 * Class CatalogServiceProvider
 * @package Bydedi\Catalog
 */
class CatalogServiceProvider extends ServiceProvider
{

    /**
     * Register the service provider.
     *
     * @return void
     */
    public function register()
    {
        $loader = new YamlFileLoader($this->serviceContainer, new FileLocator(__DIR__));
        $loader->load('config/services.yml');

        if ($this->serviceContainer->hasParameter('app.entity')) {
            $pathsEntity = $this->serviceContainer->getParameter('app.entity');
        }
        $pathsEntity[] = __DIR__ . '/Entity';
        $this->serviceContainer->setParameter('app.entity', $pathsEntity);
    }
}
