<?php

namespace Bydedi\Catalog\Entity;

use Doctrine\ORM\Mapping as ORM;
use Knp\DoctrineBehaviors\Model as ORMBehaviors;

/**
 * Class Ads
 * @package Bydedi\Catalog\Entity
 *
 * @ORM\MappedSuperclass
 */
abstract class Ads
{
    use ORMBehaviors\Translatable\Translatable;
    use ORMBehaviors\Timestampable\Timestampable;

    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

    /**
     * @var integer
     *
     * @ORM\Column(type="integer", nullable=false)
     */
    protected $rang;

    /**
     * @var \Entity\Shop[]
     *
     * @ORM\ManyToMany(targetEntity="Entity\Shop")
     * @ORM\JoinTable(name="ads_shop",
     *      joinColumns={@ORM\JoinColumn(name="ads_id", referencedColumnName="id")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="shop_id", referencedColumnName="id", unique=true)}
     *      )
     */
    protected $shop;

    /**
     * @var AdsEmplacement
     *
     * @ORM\ManyToOne(targetEntity="Bydedi\Catalog\Entity\AdsEmplacement")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="ads_emplacement_id", referencedColumnName="id")
     * })
     */
    protected $emplacement;

    /**
     * @param $method
     * @param $arguments
     * @return mixed
     */
    public function __call($method, $arguments)
    {
        return $this->proxyCurrentLocaleTranslation($method, $arguments);
    }

    /**
     * Get Id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set adsRang
     *
     * @param integer $rang
     *
     * @return Ads
     */
    public function setRang($rang)
    {
        $this->rang = $rang;

        return $this;
    }

    /**
     * Get adsRang
     *
     * @return integer
     */
    public function getRang()
    {
        return $this->rang;
    }
}
