<?php

namespace Bydedi\Catalog\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Class ProductType
 * @package Bydedi\Catalog\Entity
 *
 * @ORM\MappedSuperclass
 */
abstract class ProductType
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

    /**
     * @var string
     *
     * @ORM\Column(type="string", length=255, nullable=false)
     */
    protected $name;

    /**
     * @var integer
     *
     * @ORM\Column(name="have_stock", type="boolean", nullable=false)
     */
    protected $haveStock = 1;

    /**
     * @var integer
     *
     * @ORM\Column(name="have_shipping", type="boolean", nullable=false)
     */
    protected $haveShipping = 1;

    /**
     * @var integer
     *
     * @ORM\Column(name="have_tax", type="boolean", nullable=false)
     */
    protected $haveTax = 1;

    /**
     * @var boolean
     *
     * @ORM\Column(name="is_unique", type="boolean", nullable=false)
     */
    protected $isUnique = '0';

    /**
     * @var string
     *
     * @ORM\Column(type="string", length=255, nullable=false)
     */
    protected $classname;

    /**
     * @var string
     *
     * @ORM\Column(type="string", length=255, nullable=false)
     */
    protected $tpl;

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param mixed $id
     * @return ProductType
     */
    public function setId($id)
    {
        $this->id = $id;
        return $this;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param string $name
     * @return ProductType
     */
    public function setName($name)
    {
        $this->name = $name;
        return $this;
    }

    /**
     * @return int
     */
    public function getHaveStock()
    {
        return $this->haveStock;
    }

    /**
     * @param int $haveStock
     * @return ProductType
     */
    public function setHaveStock($haveStock)
    {
        $this->haveStock = $haveStock;
        return $this;
    }

    /**
     * @return int
     */
    public function getHaveShipping()
    {
        return $this->haveShipping;
    }

    /**
     * @param int $haveShipping
     * @return ProductType
     */
    public function setHaveShipping($haveShipping)
    {
        $this->haveShipping = $haveShipping;
        return $this;
    }

    /**
     * @return int
     */
    public function getHaveTax()
    {
        return $this->haveTax;
    }

    /**
     * @param int $haveTax
     * @return ProductType
     */
    public function setHaveTax($haveTax)
    {
        $this->haveTax = $haveTax;
        return $this;
    }

    /**
     * @return boolean
     */
    public function isIsUnique()
    {
        return $this->isUnique;
    }

    /**
     * @param boolean $isUnique
     * @return ProductType
     */
    public function setIsUnique($isUnique)
    {
        $this->isUnique = $isUnique;
        return $this;
    }

    /**
     * @return string
     */
    public function getClassname()
    {
        return $this->classname;
    }

    /**
     * @param string $classname
     * @return ProductType
     */
    public function setClassname($classname)
    {
        $this->classname = $classname;
        return $this;
    }

    /**
     * @return string
     */
    public function getTpl()
    {
        return $this->tpl;
    }

    /**
     * @param string $tpl
     * @return ProductType
     */
    public function setTpl($tpl)
    {
        $this->tpl = $tpl;
        return $this;
    }
}
